unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, LCLProc,
  StdCtrls, ComCtrls, ExtCtrls, dos;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ProgressBar1: TProgressBar;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioGroup1: TRadioGroup;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1;
  fi, fo : Text;
  s, s2 : String;
  c : char;
  i, j , sec : Integer;
  moze : boolean;
  ho1, mi1, se1, mis1, ho2, mi2, se2, mis2 : Word;

implementation

{$R *.lfm}

{ TForm1 }

function ConvertSekToTime(sek : integer):String;
var hours, minutes, seconds, divisor_for_minutes : integer;
    stime : String;
begin
    hours:= trunc(sek / (60 * 60));
    divisor_for_minutes:= sek mod (60 * 60);
    minutes:= trunc(divisor_for_minutes / 60);
    seconds:= trunc(divisor_for_minutes mod 60);
    stime:='';
    if hours > 0 then stime:=IntToStr(hours)+'h ';
    if minutes > 0 then stime:=stime+IntToStr(minutes)+'m ';
    stime:=stime+IntToStr(seconds)+'s';
    ConvertSekToTime:=stime;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     sec:=0;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  Label1.Visible:=False;
  GetTime(ho1, mi1, se1, mis1);
  s:='';
  s2:='';
  AssignFile(fi, trim(Edit1.Text));
  reset(fi);
  while not(eof(fi)) do begin
   read(fi, c);
   if not((c = #13) OR (c = #10)) then s:=s+c;
  end; // while
  CloseFile(fi);
  ProgressBar1.SetFocus;
  ProgressBar1.Min:=1;
  ProgressBar1.Max:=UTF8Length(s) DIV 1000;
  ProgressBar1.Step:=1;
  ProgressBar1.Position:=1;
  ProgressBar1.Smooth:=True;

  for i:=1 to UTF8Length(s) do begin
  if i mod 1000 = 0 then begin
   ProgressBar1.Position:=ProgressBar1.Position+1;
   Application.Processmessages;
  end; // if i mod
   moze:=true;
   if (UTF8Copy(s, i-1, 1) <> '$') AND (UTF8Copy(s, i, 1)='$') then begin
                if radiobutton1.checked then s2:=s2+#10+'$';
                if radiobutton2.checked then s2:=s2+#13#10+'$';
                if radiobutton3.checked then s2:=s2+#13+'$';
                moze:=false;
                end;
   if (UTF8Copy(s, i, 1) = '.') then begin
                   if radiobutton1.checked then s2:=s2+'.'+#10;
                   if radiobutton2.checked then s2:=s2+'.'+#13#10;
                   if radiobutton3.checked then s2:=s2+'.'+#13;
                    moze:=false;
                end;
   if moze then s2:=s2+UTF8Copy(s, i, 1);
  end;

  AssignFile(fo, Trim(Edit2.Text));
  rewrite(fo);
  writeln(fo, s2);
  CloseFile(fo);
  GetTime(ho2, mi2, se2, mis2);
  Label1.Visible:=True;
  sec:=(ho2*3600+mi2*60+se2)-(ho1*3600+mi1*60+se1);
  Label1.Caption:=ConvertSekToTime(sec);
  ShowMessage('Done!');
end;

procedure TForm1.Button2Click(Sender: TObject);
var s : String;
begin
  s:='Programmer: Aleksandar Josifoski'+#13#10;
  s:=s+'email: josifoski@gmail.com'+#13#10#13#10;
  s:=s+'txt2dot'+#13#10#13#10;
  s:=s+'licence: gpl'+#13#10#13#10;
  s:=s+'This is auxiliary tool for anytext file'+#13#10;
  s:=s+'Purpose is to make new text file based on existing'+#13#10;
  s:=s+'After every . (dot) it makes new line'+#13#10;
  s:=s+'OS determines line endings format';
  ShowMessage(s);

end;

end.

